#include "Common.h"

//============================================================
// 摜

// 쐬
Bitmap^ CreateImage(int width, int height) {
	try {
		Bitmap^ image=gcnew Bitmap(width, height);
		if (!image) throw gcnew Exception();
		Graphics^ g=Graphics::FromImage(image);
		g->FillRectangle(Brushes::White, 0, 0, image->Width, image->Height);
		return image;
	} catch (Exception^) {
		MessageBox::Show("rbg}bv̍쐬Ɏs܂");
	}
	return nullptr;
}

// 쐬eXg
void TestCreateImage(PictureBox^ pb) {
	pb->Image=CreateImage(pb->ClientSize.Width, pb->ClientSize.Height);
}

// ҏW
bool EditImage(Image^ image, int x, int y) {
	if (!image) {
		MessageBox::Show("摜܂");
		return false;
	}
	int size=20;
	Graphics^ g=Graphics::FromImage(image);
	g->FillEllipse(Brushes::Black, x-size/2, y-size/2, size, size);
	return true;
}

// o
bool SaveImage(Image^ image, String^ file_name, ImageFormat^ format) {
	if (!image) {
		MessageBox::Show("摜܂");
		return false;
	}
	try {
		image->Save(file_name, format);
		return true;
	} catch (ArgumentNullException^) {
		MessageBox::Show("t@C܂͌`kł");	
	} catch (ExternalException^) {
		MessageBox::Show("摜K؂Ȍ`ŕۑ܂ł", file_name);
	}
	return false;
}

// o̓eXg
void TestSaveImage(PictureBox^ pb) {
	if (
		SaveImage(pb->Image, "test.bmp", ImageFormat::Bmp) &&
		SaveImage(pb->Image, "test.jpg", ImageFormat::Jpeg) &&
		SaveImage(pb->Image, "test.png", ImageFormat::Png)
	) {
		MessageBox::Show("摜̏o͂ɐ܂");
	}
}

// 
Image^ LoadImage(String^ file_name) {
	try {
		return gcnew Bitmap(gcnew Bitmap(file_name));
	} catch (ArgumentException^) {
		MessageBox::Show("摜t@CȂA`sK؂ł");
	}
	return nullptr;
}

// ̓eXgibmpj
void TestLoadBmpImage(PictureBox^ pb) {
	Image^ image=LoadImage("test.bmp");
	if (image) {
		MessageBox::Show("摜t@C̓͂ɐ܂");
		pb->Image=image;
	}
}

// ̓eXgijpegj
void TestLoadJpegImage(PictureBox^ pb) {
	Image^ image=LoadImage("test.jpg");
	if (image) {
		MessageBox::Show("摜t@C̓͂ɐ܂");
		pb->Image=image;
	}
}

// ̓eXgipngj
void TestLoadPngImage(PictureBox^ pb) {
	Image^ image=LoadImage("test.png");
	if (image) {
		MessageBox::Show("摜t@C̓͂ɐ܂");
		pb->Image=image;
	}
}

// Nbv{[hɕۑ
bool SetImageToClipboard(Image^ image) {
	if (!image) {
		MessageBox::Show("摜܂");
		return false;	
	}
	Clipboard::SetImage(image);
	return true;
}

// Nbv{[hɕۑeXg
void TestSetImageToClipboard(PictureBox^ pb) {
	if (SetImageToClipboard(pb->Image)) {
		MessageBox::Show("摜Nbv{[hɕۑ܂");
	}
}

// Nbv{[h擾
Image^ GetImageFromClipboard() {
	if (Clipboard::ContainsImage()) {
		return Clipboard::GetImage();
	}
	MessageBox::Show("Nbv{[hɉ摜܂");
	return nullptr;
}

// Nbv{[h擾eXg
void TestGetImageFromClipboard(PictureBox^ pb) {
	Image^ image=GetImageFromClipboard();
	if (image) {
		pb->Image=image;
		MessageBox::Show("摜Nbv{[h擾܂");
	}
}

//============================================================
// ʃLv`

// ʃLv`
Image^ CaptureScreen() {
	try {
		Bitmap^ image=gcnew Bitmap(Screen::PrimaryScreen->Bounds.Width, Screen::PrimaryScreen->Bounds.Height);
		Graphics^ g=Graphics::FromImage(image);
		g->CopyFromScreen(Point(0, 0), Point(0, 0), image->Size);
		return image;
	} catch (Exception^) {
		MessageBox::Show("rbg}bv̍쐬Ɏs܂");
	}
	return nullptr;
}

// Lv`̃eXg
void TestCaptureScreen(PictureBox^ pb) {
	Image^ image=CaptureScreen();
	if (image) {
		pb->Image=image;
		MessageBox::Show("ʂLv`܂");
	}
}

// Lv`Əo͂̃eXg
void TestCaptureSaveScreen(PictureBox^ pb) {
	
	// ʂLv`
	Image^ image=CaptureScreen();
	
	// Lv`ɐAʂ̉摜t@Cɕۑ
	if (
		image &&
		SaveImage(image, "capture.png", ImageFormat::Png)
	) {
		// ۑɐA摜ƃbZ[W\
		pb->Image=image;
		MessageBox::Show("ʂLv`ĕۑ܂");
	}
}

//============================================================
// ʃLv`iWin32j

// ʃLv`
HBITMAP CaptureScreenWin32() {
	HWND hwnd=GetDesktopWindow();
	HDC hdc_src=GetWindowDC(hwnd);
	HDC hdc_dst=CreateCompatibleDC(hdc_src);
	RECT rect;
	GetWindowRect(hwnd, &rect);
	int w=rect.right-rect.left;
	int h=rect.bottom-rect.top;
	HBITMAP bitmap=CreateCompatibleBitmap(hdc_dst, w, h);
	SelectObject(hdc_dst, bitmap);
	BitBlt(hdc_dst, 0, 0, w, h, hdc_src, 0, 0, SRCCOPY);
	ReleaseDC(hwnd, hdc_src);
	DeleteDC(hdc_dst);
	return bitmap;
}

// ʃLv`̃eXg
void TestCaptureScreenWin32(PictureBox^ pb) {
	HBITMAP bmp=CaptureScreenWin32();
	if (bmp) {
//		pb->Image=gcnew Bitmap(bmp);
		MessageBox::Show("ʂLv`܂");
	}
}

//============================================================
// ǎ̐ݒ

// ǎ̐ݒiWin32j
bool SetWallPaperWin32(WCHAR* file) {
	if (SystemParametersInfo(
		SPI_SETDESKWALLPAPER, 0, file, 
		SPIF_UPDATEINIFILE|SPIF_SENDWININICHANGE)!=0
	) {
		return true;
	}
	::MessageBox(0, L"ǎ̐ݒɎs܂", L"", MB_OK);
	return false;
}

// ǎ̐ݒ
bool SetWallPaper(String^ file) {
	pin_ptr<WCHAR> buf=&file->ToCharArray()[0];
	return SetWallPaperWin32(buf);
}

// t@Cǎɐݒ肷eXg
#undef GetCurrentDirectory
void TestSetWallPaper() {
	if (SetWallPaper(Directory::GetCurrentDirectory()+"\\test.bmp")) {
		MessageBox::Show("ǎ̐ݒɐ܂");
	}
}

// t@Cǎɐݒ肷eXgiWin32j
void TestSetWallPaperWin32() {
	WCHAR dir[MAX_PATH];
	GetCurrentDirectoryW(MAX_PATH, dir);
	WCHAR path[MAX_PATH];
	swprintf_s(path, MAX_PATH, L"%s\\test.bmp", dir);
	if (SetWallPaperWin32(path)) {
		::MessageBox(0, L"ǎ̐ݒɐ܂", L"", MB_OK);
	}
}

// \Ă摜ǎɐݒ肷eXg
void TestSetWallPaperFromScreen(PictureBox^ pb) {
	if (
		SaveImage(pb->Image, "test.bmp", ImageFormat::Bmp) &&
		SetWallPaper(Directory::GetCurrentDirectory()+"\\test.bmp")
	) {
		MessageBox::Show("ǎ̐ݒɐ܂");
	}
}

//============================================================
// Ot̕`

// _Ot̕`
bool DrawBarGraph(Image^ image, array<int>^ data) {
	int n=data->Length;
	if (n<=0) {
		MessageBox::Show("f[^܂");
		return false;
	}
	int max_value=0;
	for (int i=0; i<n; i++) {
		if (max_value<data[i]) max_value=data[i];
	}
	int iw=image->Width;
	int ih=image->Height;
	Graphics^ g=Graphics::FromImage(image);
	for (int i=0; i<n; i++) {
		if (data[i]>0) {
			float w=(float)iw/n;
			float h=(float)ih*data[i]/max_value;
			g->FillRectangle(Brushes::Black, i*w, ih-h, w, h);
			g->DrawRectangle(Pens::White, i*w, ih-h, w, h);
		}
	}
	return true;
}

// _Ot̃eXg
void TestDrawBarGraph(PictureBox^ pb) {
	array<int>^ data={12, 34, 56, 78, 43, 21};
	Image^ image=CreateImage(pb->Width, pb->Height);
	DrawBarGraph(image, data);
	pb->Image=image;
}

// ܂Ot̕`
bool DrawLineGraph(Image^ image, array<int>^ data) {
	int n=data->Length;
	if (n<=0) {
		MessageBox::Show("f[^܂");
		return false;
	}
	int max_value=0;
	for (int i=0; i<n; i++) {
		if (max_value<data[i]) max_value=data[i];
	}
	int iw=image->Width;
	int ih=image->Height;
	array<Point>^ p=gcnew array<Point>(n);
	Graphics^ g=Graphics::FromImage(image);
	for (int i=0; i<n; i++) {
		p[i].X=i*iw/n+iw/n/2;
		if (data[i]>0) {
			p[i].Y=ih-(ih-10)*data[i]/max_value;
		} else {
			p[i].Y=0;
		}
		g->FillEllipse(Brushes::Black, p[i].X-5, p[i].Y-5, 10, 10);
	}
	Pen^ pen=gcnew Pen(Brushes::Black, 4);
	g->DrawLines(pen, p);
	return true;
}

// ܂Ot̃eXg
void TestDrawLineGraph(PictureBox^ pb) {
	array<int>^ data={12, 34, 56, 78, 43, 21};
	Image^ image=CreateImage(pb->Width, pb->Height);
	DrawLineGraph(image, data);
	pb->Image=image;
}

// ~Ot̕`
bool DrawCircleGraph(Image^ image, array<int>^ data) {
	int n=data->Length;
	if (n<=0) {
		MessageBox::Show("f[^܂");
		return false;
	}
	int sum=0;
	for each (int i in data) sum+=i;
	float iw=(float)image->Width;
	float ih=(float)image->Height;
	float rad=min(iw, ih)/2;
	Graphics^ g=Graphics::FromImage(image);
	float angle=-90;
	array<Brush^>^ brush={Brushes::Black, Brushes::DarkGray, Brushes::Gray, Brushes::LightGray};
	for (int i=0; i<n; i++) {
		if (data[i]>0) {
			float diff=(float)360*data[i]/sum;
			g->FillPie(brush[i%brush->Length], iw/2-rad, ih/2-rad, rad*2, rad*2, angle, diff);
			angle+=diff;
		}
	}
	return true;
}

// ~Ot̃eXg
void TestDrawCircleGraph(PictureBox^ pb) {
	array<int>^ data={12, 34, 56, 78, 43, 21};
	Image^ image=CreateImage(pb->Width, pb->Height);
	DrawCircleGraph(image, data);
	pb->Image=image;
}

//============================================================
// 

ref class ImagePrinter {
	Image^ image;
public:
	ImagePrinter(Image^ image) {
		this->image=image;
	}

	void PrintHandler(Object^ sender, PrintPageEventArgs^ e) {
		e->Graphics->DrawImage(image, e->MarginBounds);
		e->HasMorePages=false;
	}

	// 
	bool Print() {
		if (!image) {
			MessageBox::Show("摜܂");
			return false;
		}
		PrintDocument^ document=gcnew PrintDocument();
		document->PrintPage+=gcnew PrintPageEventHandler(this, &ImagePrinter::PrintHandler);
		PrintDialog^ dialog=gcnew PrintDialog();
		dialog->Document=document;
		if (dialog->ShowDialog()==DialogResult::OK) {
			document->Print();
			return true;
		}
		return false;
	}

	// vr[
	bool Preview() {
		if (!image) {
			MessageBox::Show("摜܂");
			return false;
		}
		PrintDocument^ document=gcnew PrintDocument();
		document->PrintPage+=gcnew PrintPageEventHandler(this, &ImagePrinter::PrintHandler);
		PrintPreviewDialog^ preview=gcnew PrintPreviewDialog();
		preview->Document=document;
		preview->ShowDialog();
		return true;
	}
};


// ̃eXg
void TestPrint(PictureBox^ pb) {
	ImagePrinter^ ip=gcnew ImagePrinter(pb->Image);
	if (ip->Print()) {
		MessageBox::Show("s܂");
	}
}

// vr[̃eXg
void TestPrintPreview(PictureBox^ pb) {
	ImagePrinter^ ip=gcnew ImagePrinter(pb->Image);
	ip->Preview();
}

//============================================================
// `EBhE

// }EX{^Ƃ̃Cxgnh
void ShapedWindowEventHandler(Object^ object, MouseEventArgs^ e) {
	ReleaseCapture();
	Form^ form=(Form^)object;
	SendMessage((HWND)form->Handle.ToPointer(), WM_SYSCOMMAND, SC_MOVE|2, 0);
}

// `EBhE
bool CreateShapedWindow(Image^ image, Color key) {
	if (!image) {
		MessageBox::Show("摜܂");
		return false;
	}
	Form^ form=gcnew Form();
	form->FormBorderStyle=FormBorderStyle::None;
	form->Size=image->Size;
	form->BackgroundImage=image;
	form->TransparencyKey=key;
	form->MouseDown+=gcnew MouseEventHandler(ShapedWindowEventHandler);
	form->Show();
	return true;
}

// `EBhẼeXg
void TestCreateShapedWindow(PictureBox^ pb) {
	CreateShapedWindow(pb->Image, Color::White);
}

//============================================================
// EBhE

// EBhE
void SetWindowAlpha(Form^ form, double alpha) {
	if (0<=alpha && alpha<=1) form->Opacity=alpha;
	if (alpha>=1) form->AllowTransparency=false;
}

